
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <io.h>
#include <dir.h>
#include <dos.h>
#include <time.h>

#pragma hdrstop

#define MAX_LEN 1024

int count=0;

void process_file(const char* fname)
{
  FILE*f=fopen(fname,"rb");
  if (f==NULL) return;
  BYTE x[8];
  if (fread(x, 1,sizeof(x), f) != sizeof(x))
  {
    fclose(f);
    return;
  }
  fclose(f);
  if ((x[0]!=0x4C)||(x[1]!=0x01)) return;

  count++;

  long t = *(long*)&x[4];
  char* s = ctime(&t);
  s[strlen(s)-1]=0;
  printf("%08X  %s  %s\n", t, s, fname);
}

void recsearch(const char* path0)
{
  char path[MAX_LEN];
  strcpy(path, path0);
  if (path[strlen(path)-1] != '\\') strcat(path, "\\");
  char *c = strchr(path, 0);
  strcpy(c, "*.*");
  struct ffblk ff;
  for (int done=findfirst(path, &ff, FA_ARCH|FA_DIREC|FA_RDONLY|FA_HIDDEN|FA_SYSTEM);
       !done;
       done=findnext(&ff))
  {
    strcpy(c, ff.ff_name);
    if (ff.ff_attrib & FA_DIREC)
      if (ff.ff_name[0] != '.')
        recsearch(path);
      else
        ;
    else
      process_file(path);
  }//for
}//recsearch

void help()
{
  printf(".OBJ Time Dumper  (x) 2001\n"\
         "\n"\
         "syntax:\n"\
         "  OTD file(s)\n");
  exit(0);
}//help

void main(int argc, char* argv[])
{
  if (argc<=1) help();

  for (int i=1; i<argc; i++)
  {
    if (argv[i][0]=='/')
    {
      if (   ((argv[i][1]|0x20)=='h') ||
             (argv[i][1]=='?')   )  help();
    }
  }//for i

  for (int i=1; i<argc; i++)
  {
    if (argv[i][0]!='/')
    {
      if (  strchr(argv[i],'?') ||
            strchr(argv[i],'*') ||
            (argv[i][ strlen(argv[i])-1 ] == '\\')
         )
      {
        recsearch(argv[i]);
      }
      else
      {
        struct ffblk ff;
        if (!findfirst(argv[i], &ff, FA_ARCH|FA_DIREC|FA_RDONLY|FA_HIDDEN|FA_SYSTEM))
        if (ff.ff_attrib & FA_DIREC)
          recsearch(argv[i]);
        else
          process_file(argv[i]);
      }
    }
  }//for i

  printf("COFF OBJ files: %i\n", count);

}//main
